﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net.Mail;
using System.Configuration;
using System.Net.Configuration;

namespace MailFormApp
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

        }
        protected void Button1_Click(object sender, EventArgs e)
        {
            SmtpSection mySmtpSection = (SmtpSection)ConfigurationManager.GetSection("system.net/mailSettings/smtp");
            //メールメッセージの本文を作ります。
            string mailMessage = "";
            mailMessage += "メールアドレス：" + Server.HtmlEncode(TextBox1.Text) + "<br />";
            mailMessage += "件名：" + Server.HtmlEncode(TextBox2.Text) + "<br />";
            mailMessage += "内容：" + Server.HtmlEncode(TextBox3.Text).Replace("\n", "<br />");
            //新しいメールメッセージオブジェクトを宣言します。
            MailMessage myMessage = new MailMessage();
            //メールメッセージオブジェクトを完成させます。
            myMessage.From = new MailAddress(mySmtpSection.From, ConfigurationManager.AppSettings["送信元表示名"]);  //送信者の入力
            string[,] mailToArray = new string[2, Convert.ToInt32(ConfigurationManager.AppSettings["宛先数"])];
            foreach (string Str in ConfigurationManager.AppSettings.AllKeys)
            {
                if (Str.StartsWith("宛先メールアドレス"))
                    mailToArray[0, Convert.ToInt32(Str.Substring(9)) - 1] = ConfigurationManager.AppSettings[Str];
                if (Str.StartsWith("宛先表示名"))
                    mailToArray[1, Convert.ToInt32(Str.Substring(5)) - 1] = ConfigurationManager.AppSettings[Str];
            }
            for (int i = 0; i < Convert.ToInt32(ConfigurationManager.AppSettings["宛先数"]); i++)
            {
                myMessage.To.Add(new MailAddress(mailToArray[0,i], mailToArray[1,i])); //受信者の追加
            }
            myMessage.Subject = ConfigurationManager.AppSettings["件名"];         //件名の追加
            myMessage.Body = mailMessage;                                           //メール本文の登録
            if (Label4.Text != "")
            {
                System.IO.MemoryStream postedFileStream = new System.IO.MemoryStream(Convert.FromBase64String(HiddenField1.Value));
                myMessage.Attachments.Add(new Attachment((System.IO.Stream)postedFileStream, Label4.Text, HiddenField2.Value));
            }
            myMessage.BodyEncoding = System.Text.Encoding.UTF8;                     //メールの文字コードを宣言
            myMessage.IsBodyHtml = true;                                            //メールがHTMLメールであることを宣言
            //新しい送信オブジェクトを宣言します。
            SmtpClient myClient = new SmtpClient();
            //送信オブジェクトを完成させます。
            myClient.UseDefaultCredentials = true;
            //メールメッセージを送信します。
            myClient.Send(myMessage);
            //後処理
            myMessage.Dispose();                                                    //メッセージオブジェクトの削除
            //お礼ページ（別途用意）に飛ばします。
            Response.Redirect(ConfigurationManager.AppSettings["お礼ページへのURL"]);
        }

        protected void Button2_Click(object sender, EventArgs e)
        {
            //添付ファイルを受け取ります
            HttpPostedFile postedFimeObject = Request.Files[0];
            Label1.Text = Server.HtmlEncode(TextBox1.Text);
            Label2.Text = Server.HtmlEncode(TextBox2.Text);
            Label3.Text = Server.HtmlEncode(TextBox3.Text).Replace("\n", "<br />");
            if (postedFimeObject.FileName != "")
            {
                Label4.Text = System.IO.Path.GetFileName(postedFimeObject.FileName);
                byte[] cByteStream = new byte[postedFimeObject.ContentLength];
                postedFimeObject.InputStream.Read(cByteStream, 0, postedFimeObject.ContentLength);
                HiddenField1.Value = Convert.ToBase64String(cByteStream);
                HiddenField2.Value = postedFimeObject.ContentType;
            }
            else
            {
                Label4.Text = "";
                HiddenField1.Value = "";
                HiddenField2.Value = "";
            }
            Panel1.Visible = false;
            Panel2.Visible = true;
        }

        protected void Button3_Click(object sender, EventArgs e)
        {
            Panel1.Visible = true;
            Panel2.Visible = false;
        }
    }
}
